class Q3
{
public:
  FILE *f1, *f2;
  int maxhost;
  int *byte_freq;
  int byte_num;

  Q3()
  {
    int i;
    maxhost=1289;
    byte_num = 0;
    byte_freq = new int[maxhost];
    f1=fopen("q3p.txt","wt");
    f2=fopen("q3c.txt","wt");
    if (!f1 || !f2)
    {
        printf("Cannot create file\n");
        return;
    }
    for (i=0; i<maxhost; i++)
      byte_freq[i] = 0;
  };

  ~Q3()
  {
    int i;

    // sort result
    qsort(byte_freq,maxhost,sizeof(int),compare);

    // get the number of distinct hosts
    while (byte_freq[maxhost-1]==0)
      maxhost--;

    // output result
    for (i=0; i<maxhost; i++)
      fprintf(f1,"%d\t%lf\n",i+1,double(byte_freq[i])/byte_num);

    // compute accumulative num
    for (i=1; i<maxhost; i++)
      byte_freq[i] += byte_freq[i-1];

    // output result
    for (i=0; i<maxhost; i++)
      fprintf(f2,"%d\t%lf\n",i+1,double(byte_freq[i])/byte_num);

    delete byte_freq;
    fclose(f1);
    fclose(f2);
  };

  void process_one(double time, int host, int size)
  {
    byte_num += size;
    assert(byte_num>0);
    byte_freq[host] += size;
  };
};
