#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

#include "q1.h"
#include "q2.h"
#include "q3.h"
#include "q4.h"
#include "q5.h"

void main(void)
{
    char *fname="..\\tcp.txt";
    FILE *f;

    int line=0;
    int host, size;
    double time;
    Q1 q1;
    Q2 q2;
    Q3 q3;
    Q4 q4;
    Q5 q5;

    f=fopen(fname,"rt");
    if (!f)
    {
        printf("Cannot open file\n");
        return;
    }

    while (fscanf(f,"%lf%d%d\n",&time,&host,&size)==3)
    {
        line++;
        q1.process_one(time,host,size);
        q2.process_one(time,host,size);
        q3.process_one(time,host,size);
        q4.process_one(time,host,size);
        q5.process_one(time,host,size);
    }
    fclose(f);
}