cd 'd:\wwg\855\ass1'

# Question 1
set terminal png
set title "Packet Size Frequency Distribution"
set xlabel "Packet Size"
set ylabel "Packet Size Frequency"
set format y "%g%%"
set nologscale y
set output "q1a.png"
plot [0:1600] [0:50] "q1.txt" title "Packet Size Frequency" with boxes

set terminal png
set title "Packet Size Frequency Distribution"
set xlabel "Packet Size"
set ylabel "Packet Size Frequency (Percent)"
set logscale y
set format y "%g%%"
set output "q1b.png"
plot [0:1600] [0.0001:100] "q1.txt" title "Packet Size Frequency" with boxes

# Question 2
set terminal png 
set title "Packet Traffic On Hosts"
set xlabel "Host"
set ylabel "Packet Traffic Fraction"
set nologscale y
set format y "%4.1f"
set output "q2.png"
plot [0:1214] [0:1] "q2c.txt" title "Cumulative Traffic Fraction" with lines, "q2p.txt" title "Traffic Fraction" with lines

# Question 3
set terminal png
set title "Byte Traffic On Hosts"
set xlabel "Host"
set ylabel "Byte Traffic Fraction"
set nologscale y
set format y "%4.1f"
set output "q3.png"
plot [0:1214] [0:1] "q3c.txt" title "Cumulative Traffic Fraction" with lines, "q3p.txt" title "Traffic Fraction" with lines

# Question 4
# interval 1 second
set terminal png
set title "Byte Traffic Per 1 Second"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q41.png"
plot [0:] [0:] "q41.txt" title "Byte Traffic" with lines

# Question 4
# interval 0.1 second
set terminal png
set title "Byte Traffic Per 0.1 Second"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q401.png"
plot [0:] [0:] "q401.txt" title "Byte Traffic" with lines

# Question 4
# interval 10 second
set terminal png
set title "Byte Traffic Per 10 Second"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q410.png"
plot [0:] [0:] "q410.txt" title "Byte Traffic" with lines

# Question 5
# interval 1 second
set terminal png
set title "Byte Traffic Per 1 Second on Host 4"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q51.png"
plot [0:] [0:] "q51.txt" title "Byte Traffic" with lines

# Question 5
# interval 0.1 second
set terminal png
set title "Byte Traffic Per 0.1 Second on Host 4"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q501.png"
plot [0:] [0:] "q501.txt" title "Byte Traffic" with lines

# Question 5
# interval 10 second
set terminal png
set title "Byte Traffic Per 10 Second on Host 4"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q510.png"
plot [0:] [0:] "q510.txt" title "Byte Traffic" with lines

# Question 5 no host 4
# interval 1 second
set terminal png
set title "Byte Traffic Per 1 Second on Host 4"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q61.png"
plot [0:] [0:] "q61.txt" title "Byte Traffic" with lines

# Question 5 no host 4
# interval 0.1 second
set terminal png
set title "Byte Traffic Per 0.1 Second on Host 4"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q601.png"
plot [0:] [0:] "q601.txt" title "Byte Traffic" with lines

# Question 5 no host 4
# interval 10 second
set terminal png
set title "Byte Traffic Per 10 Second on Host 4"
set xlabel "Time"
set ylabel "Byte"
set nologscale y
set format y "%.0f"
set output "q610.png"
plot [0:] [0:] "q610.txt" title "Byte Traffic" with lines

set terminal png
set output "temp.png"
plot sin(x)
quit

