class Q5
{
public:
  FILE *f1, *f2, *f3;
  int maxtime1, maxtime01, maxtime10;
  int *byte_freq1, *byte_freq01, *byte_freq10;
  double pre_time1, pretime01, pretime10;
  double interval1, interval01, interval10;
  int byte_num;

  Q5()
  {
    int i;
    byte_num = 0;
    interval1  =  1;
    interval01 =0.01;
    interval10 = 10;

    maxtime1 = 4198+2;
    byte_freq1 = new int[maxtime1];

    maxtime01   = maxtime1*100+2;
    byte_freq01 = new int[maxtime01];

    maxtime10   = maxtime1/10+2;
    byte_freq10 = new int[maxtime10];

    f1=fopen("q51.txt","wt");
    f2=fopen("q5001.txt","wt");
    f3=fopen("q510.txt","wt");
    if (!f1 || !f2 || !f3)
    {
        printf("Cannot create file\n");
        return;
    }
    for (i=0; i<maxtime1; i++)
      byte_freq1[i] = 0;
    for (i=0; i<maxtime01; i++)
      byte_freq01[i] = 0;
    for (i=0; i<maxtime10; i++)
      byte_freq10[i] = 0;
  };

  ~Q5()
  {
    int i;

    while (byte_freq1[maxtime1-1]==0)
      maxtime1--;

    while (byte_freq01[maxtime01-1]==0)
      maxtime01--;

    while (byte_freq10[maxtime10-1]==0)
      maxtime10--;

    // compute average
    int s=0;
    for (i=0; i<maxtime1; i++)
      s += byte_freq1[i];
    s /= maxtime1;  // average

    s=0;
    for (i=0; i<maxtime01; i++)
    {
      if (s<byte_freq01[i])
        s=byte_freq01[i];
    }

    //  s += byte_freq01[i];
    //s /= maxtime01;  // average

    s=0;
    for (i=0; i<maxtime10; i++)
      s += byte_freq10[i];
    s /= maxtime10;  // average

    // output result
    for (i=0; i<maxtime1; i++)
      fprintf(f1,"%lf\t%d\n",i*interval1,byte_freq1[i]);

    for (i=0; i<maxtime01; i++)
      fprintf(f2,"%lf\t%d\n",i*interval01,byte_freq01[i]);

    for (i=0; i<maxtime10; i++)
      fprintf(f3,"%lf\t%d\n",i*interval10,byte_freq10[i]);

    delete byte_freq1;
    delete byte_freq01;
    delete byte_freq10;
    fclose(f1);
    fclose(f2);
    fclose(f3);
  };

  void process_one(double time, int host, int size)
  {
    if (host!=4)
      return;

    byte_num += size;
    assert(byte_num>0);

    assert(int(time/interval1)<maxtime1);
    assert(int(time/interval01)<maxtime01);
    assert(int(time/interval10)<maxtime10);

    byte_freq1 [int(time/interval1) ] += size;
    byte_freq01[int(time/interval01)] += size;
    byte_freq10[int(time/interval10)] += size;
  };
};
